<?
// ---------------------------------------------------------------------------- //
// MyNewsGroups :) 'Share your knowledge'
// Copyright (C) 2002 Carlos Snchez Valle (yosoyde@bilbao.com)

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------- //


//------------------------------------------------------------------//
// newsgroups.php
// Author: Carlos Snchez
// Created: 23/06/01
//
// Description: First page of the system, it shows to us
//              the group list, the description and the
//              number of messages available. It also tell us
//              if there are new messages in a particular group.
//
//
// TODO:        In future versions, we'll check if new articles are
//              available, focusing in each user's account and
//              information.
//------------------------------------------------------------------//
?>
<?
session_start();

// Systemcheck standalone or postnuke
if(LOADED_AS_MODULE=="1") {
	// Define Modulename for Postnuke
	$ModName = basename( dirname( __FILE__ ) );
	$myng['system'] = "postnuke";
	// Include the postnuke config file
	include("modules/$ModName/config.php");
} else {
	$myng['system'] = "standalone";
	// Include the standard config file, with all the configuration and files required.
	include("config.php");	
}

$db=new My_db;
$db->connect();

// MyNG setting up...
init();

// Set up the language
modules_get_language();

// Templates
$t = new Template($_SESSION['conf_system_root']."/themes/".$_SESSION['conf_vis_theme']."/templates/");

//Registramos el momento actual
$current_time=time();

// Manage the login module
$left_bar = manage_login($current_time,$t,$db);

// Fetch the latest articles
if(!fetch_articles($cron = false)){
	// Redirect to the error page, there're no groups at the system
	header("Location:".$_SESSION['conf_system_prefix']."error.php?error_id=1");	
}

// Check if there are any newsgroups registered
$consulta = sprintf("SELECT * FROM myng_newsgroup");
$db->query($consulta);
if($db->num_rows() == 0){

        $system_info = _MYNGNOGROUPS;
        $main = "error.htm";
        $t->set_file("main",$main);
        $t->set_var("error_message",_MYNGNOGROUPS);
        // Show all the page
        show_layout($t,$left_bar,$system_info,MYNG_VERSION);
        exit();

}


$news_groups = array();

$consulta = sprintf("SELECT * from myng_server");
$db->query($consulta);

while($db->next_record()){

    // Fetch the server's data
    $serv_id = $db->Record['serv_id'];
    $server = $db->Record['serv_host'];
    $port = $db->Record['serv_port'];
    $login = $db->Record['serv_login'];
    $passwd = $db->Record['serv_passwd'];

    // Get the groups' data
    read_groups($ns,$serv_id,$port,$news_groups,$_SESSION['conf_system_zlib_yn']);

}


$system_info = _MYNGBROWSE_NG;

$main = "newsgroups.htm";
$t->set_file("main",$main);
$t->set_block("main","groups_block","groups_block_handle");

show_newsgroups($news_groups,$t);

$challenge=md5(uniqid($myng['cadena']));
$t->set_var("secret_challenge",$challenge);
// Show all the page
show_layout($t,$left_bar,$system_info,MYNG_VERSION);




// We set off the old article downloading method.
// Maybe it will be deprecated in future releases

/*
// Insert an algorithm to prevent News Server 'bombing'
mt_srand((double)microtime()*1000000);
$random_number = mt_rand(1,100);

$news_groups = array();

if($random_number <= $interval){

        // We repeat the same for all the news servers

        $consulta = sprintf("SELECT * from myng_server");
        $db->query($consulta);

        while($db->next_record()){

                // Fetch the server's data
                $server = $db->Record['host'];
                $port = $db->Record['port'];
                $login = $db->Record['login'];
                $passwd = $db->Record['passwd'];

                flush();
                $ns = OpenNNTPconnection($server,$port,$login,$passwd);

                if($ns == false){

                        // Connection Error!
                        $system_info = _MYNGCON_ERROR;
                        $main = "error.htm";
                        $t->set_file("main",$main);
                        show_layout($t,$left_bar,$system_info,$myng['version']);
                        closeNNTPconnection($ns);
                        flush();
                        exit();

                }else{

                        // Connection Completed!
                        // Get new articles.

                        // --- New Downloading and Indexing System ----------- //
                        // Setting off the actual method for debugging... ---- //

                        read_groups($ns,$server,$port,$news_groups,$myng['compression']);

                        closeNNTPconnection($ns);
                        flush();

                }


        }

}else{
        // We don't query the News Server

        $consulta = sprintf("SELECT * from myng_server");
        $db->query($consulta);

        while($db->next_record()){

                // Fetch the server's data
                $server = $db->Record['host'];
                $port = $db->Record['port'];
                $login = $db->Record['login'];
                $passwd = $db->Record['passwd'];

                $ns = false;
                // Get new articles.
                read_groups($ns,$server,$port,$news_groups,$myng['compression']);

        }

}

//echo count($news_groups);
*/




?>