<?
// ---------------------------------------------------------------------------- //
// MyNewsGroups :) 'Share your knowledge'
// Copyright (C) 2002 Carlos Snchez Valle (yosoyde@bilbao.com)

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------- //

//------------------------------------------------------------------//
// search.php
// Author: Carlos Snchez
// Created: 05/11/01
//
// Description: Search Page. We can search in the article archive.
//
//
//------------------------------------------------------------------//
?>
<?
session_start();

// Systemcheck standalone or postnuke
if(LOADED_AS_MODULE=="1") {
	// Define Modulename for Postnuke
	$ModName = basename( dirname( __FILE__ ) );
	$myng['system'] = "postnuke";
	// Include the postnuke config file
	include("modules/$ModName/config.php");
} else {
	$myng['system'] = "standalone";
	// Include the standard config file, with all the configuration and files required.
	include("config.php");
}


$db=new My_db;
$db->connect();

$db2=new My_db;
$db2->connect();

// Set up the language
modules_get_language();

// MyNG setting up...
init();

// Templates
$t = new Template($_SESSION['conf_system_root']."/themes/".$_SESSION['conf_vis_theme']."/templates/");
//$t2 = new Template($_SESSION['conf_system_root']."/themes/".$_SESSION['conf_vis_theme']."/templates/");

// Fetch the latest articles
if(!fetch_articles($cron = false)){
	// Redirect to the error page, there're no groups at the system
	header("Location:".$_SESSION['conf_system_prefix']."error.php?error_id=1");	
}

//$t->debug = true;

//Registramos el momento actual
$current_time=time();

// Manage the login module
$left_bar = manage_login($current_time,$t,$db);

// Check if there are any newsgroups registered
$consulta = sprintf("SELECT * FROM myng_newsgroup");
$db->query($consulta);

if($db->num_rows() == 0){

        $system_info = _MYNGNOGROUPS;
        $main = "error.htm";
        $t->set_file("main",$main);
        $t->set_var("error_message",_MYNGNOGROUPS);
        // Show all the page
        show_layout($t,$left_bar,$system_info,MYNG_VERSION);
        exit();

}

//Check if the query has been submitted

if($_POST['action'] == "search_group"){

        // The user threw a query
        // Search Engine Methods
        $group = real2table($_POST['group']);
        $words = $_POST['words'];

        $kw = new MyKwIndex(array(
                "index_name" => "myng_".$group,
                // MySQL data (From 'config.php')
                "hostname" => $db->Host,
                "db_name" => $db->Database,
                "username" => $db->User,
                "password" => $db->Password
        ));

        // We throw the query to the search engine
        //$doc_ids = $kw->search(array('words'=>$words,'num'=>$num+1,'start'=>$start,'boolean'=>$boolean));
        $doc_ids = $kw->search(array('words'=>$words,'boolean'=>'AND'));

        if (!isset($doc_ids))
                die("can't search: ".$kw->ERROR);
        $docs = array();

        if (sizeof($doc_ids)) {

                // Show the results
                $system_info = _MYNGSEARCH_RESULTS;
                //$main = "result.htm";
                $main = "search.htm";
                $t->set_file("main",$main);
                $t->set_block("main","result_block","result_block_handle");
                $t->set_block("main","result_table_block","result_table_block_handle");        
                
                
                // Page Text
                parse_text($t);
               
                
                
                //Fetch the article's information
                $query = sprintf("SELECT id,subject,newsgroup,name,date,num_readings,grp_id FROM `%s`,myng_newsgroup WHERE id_article IN (%s) AND grp_name = newsgroup","myng_".$group,join(',',$doc_ids));
                $db->query($query);
                
                $t->set_var('result_block_handle', ''); 

                
                while($db->next_record()){


                        $date = date("M d Y",$db->Record['date']);
                        $t->set_var("date",$date);
                        $article_url = "article.php?id_article=".rawurlencode($db->Record['id'])."&grp_id=".$db->Record['grp_id'];
                        $t->set_var("article_url",modifyLink($article_url));
                        $t->set_var("subject",$db->Record['subject']);
                        $t->set_var("sender",$db->Record['name']);
                        $t->set_var("group",$db->Record['newsgroup']);
                        $t->set_var("readings",$db->Record['num_readings']);

                        $t->parse("result_block_handle","result_block",true);

                }

                $t->parse("result_table_block_handle","result_table_block",true);
                
                // Show all the page
                //show_layout($t,$left_bar,$system_info,MYNG_VERSION);
                show_search_interface($left_bar,$error,$db);
                
                
        }else{

                // There's no result.
                // We show the search page again showing the error message
                $error = _MYNGNOARTICLES_FOUND."\"".$words."\"";
                show_search_interface($left_bar,$error,$db);

        }


}


if($_POST['action']=="search_all"){
		
        $words = $_POST['words'];
	
        $something_found = 0;
        $system_info = _MYNGSEARCH_RESULTS;
        $main = "search.htm";
        $t->set_file("main",$main);
        $t->set_block("main","result_block","result_block_handle");
        $t->set_block("main","result_table_block","result_table_block_handle");        

        // Page Text
        parse_text($t);

        //Fetch all the group's names
        $consulta = sprintf("SELECT * FROM myng_newsgroup");
        $db2->query($consulta);

        while($db2->next_record()){


                //With each group, we do a normal query.
                $group = $db2->Record['grp_name'];
                $group = real2table($group);

                $kw = new MyKwIndex(array(
                        "index_name" => "myng_".$group,
                        // MySQL data (From 'config.php')
                        "hostname" => $db->Host,
                        "db_name" => $db->Database,
                        "username" => $db->User,
                        "password" => $db->Password
                ));

                // We throw the query to the search engine
                //$doc_ids = $kw->search(array('words'=>$words,'num'=>$num+1,'start'=>$start,'boolean'=>$boolean));
                $doc_ids = $kw->search(array('words'=>$words,'boolean'=>'AND'));

                if (!isset($doc_ids))
                        die("can't search: ".$kw->ERROR);
                $docs = array();

                if (sizeof($doc_ids)) {

                        //Fetch the article's information
                        $query = sprintf("SELECT id,subject,newsgroup,name,date,num_readings FROM `%s` WHERE id_article IN (%s)","myng_".$group,join(',',$doc_ids));
                        $db->query($query);
                        while($db->next_record()){

                                $date = date("M d Y",$db->Record['date']);
                                $t->set_var("date",$date);
                                $article_url = "article.php?id_article=".rawurlencode($db->Record['id'])."&grp_id=".$db2->Record['grp_id'];
                                $t->set_var("article_url",modifyLink($article_url));
                                $t->set_var("subject",$db->Record['subject']);
                                $t->set_var("sender",$db->Record['name']);
                                $t->set_var("group",$db->Record['newsgroup']);
                                $t->set_var("readings",$db->Record['num_readings']);
                                $t->parse("result_block_handle","result_block",true);

                        }

                $something_found = 1;


                }

        }

        if($something_found == 0){
        		
                //No articles found
                $error = _MYNGNOARTICLES_FOUND." \"".$words."\"";
                show_search_interface($left_bar,$error,$db);

        }else{

                // Show the results
                //show_layout($t,$left_bar,$system_info,MYNG_VERSION);
                $t->parse("result_table_block_handle","result_table_block",true);
                show_search_interface($left_bar,$error,$db);
        }
}



if(!isset($_POST['action'])){
			
        //The user didn't throw any query
        //Show the search interface
        $error="";
        show_search_interface($left_bar,$error,$db);

}







?>

<?
// Script own functions

function show_search_interface($left_bar,$error,&$db){		

		global $t;		
		
        $system_info = _MYNGSEARCH_ENGINE;
        $main = "search.htm";
        $t->set_file("main",$main);
        $t->set_block("main","group_block","group_block_handle");        
        $t->set_block("main","result_table_block","result_table_block_handle");        

        // Build the groups list
        $consulta = sprintf("SELECT * FROM myng_newsgroup");
        $db->query($consulta);

        while($db->next_record()){
                $t->set_var("group",$db->Record['grp_name']);
                $t->parse("group_block_handle","group_block",true);
        }

        $t->set_var("error",$error);

        // Page Text
        $t->set_var("_myngsearch_engine",_MYNGSEARCH_ENGINE);
        $t->set_var("_myngsearch_one_group",_MYNGSEARCH_ONE_GROUP);
        $t->set_var("_myngsearch_all_groups",_MYNGSEARCH_ALL_GROUPS);
        $t->set_var("_myngand_operation",_MYNGAND_OPERATION);
        $t->set_var("_myngpowered_by",_MYNGPOWERED_BY);
        $t->set_var("_mynggo",_MYNGGO);

        // Show all the page
        show_layout(&$t,$left_bar,$system_info,MYNG_VERSION);

}


function parse_text(&$t){

        $t->set_var("_myngsearch_results",_MYNGSEARCH_RESULTS);
        $t->set_var("_myngdate",_MYNGDATE);
        $t->set_var("_myngsubject",_MYNGSUBJECT);
        $t->set_var("_myngauthor",_MYNGAUTHOR);
        $t->set_var("_mynggroup",_MYNGGROUP);
        $t->set_var("_myngreadings",_MYNGREADINGS);

}

?>


