<?
// ---------------------------------------------------------------------------- //
// MyNewsGroups :) 'Share your knowledge'
// Copyright (C) 2002 Carlos Snchez Valle (yosoyde@bilbao.com)

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------- //

//------------------------------------------------------------------//
// stats.php
// Author: Carlos Snchez
// Created: 06/09/01
// Last Modified: 14/09/01
//
// Description: Shows different statistics of the system.
//
//
//------------------------------------------------------------------//
?>
<?
session_start();

// Systemcheck standalone or postnuke
if(LOADED_AS_MODULE=="1") {
	// Define Modulename for Postnuke
	$ModName = basename( dirname( __FILE__ ) );
	$myng['system'] = "postnuke";
	// Include the postnuke config file
	include("modules/$ModName/config.php");
} else {
	$myng['system'] = "standalone";
	// Include the standard config file, with all the configuration and files required.
	include("config.php");
}

$db=new My_db;
$db->connect();

// MyNG setting up...
init();

// Set up the language
modules_get_language();

// Templates
$t = new Template($_SESSION['conf_system_root']."/themes/".$_SESSION['conf_vis_theme']."/templates/");

// Fetch the latest articles
if(!fetch_articles($cron = false)){
	// Redirect to the error page, there're no groups at the system
	header("Location:".$_SESSION['conf_system_prefix']."error.php?error_id=1");	
}

$current_time=time();

// Manage the login module
$left_bar = manage_login($current_time,$t,$db);

// Check if there are any newsgroups registered
$consulta = sprintf("SELECT * FROM myng_newsgroup");
$db->query($consulta);
if($db->num_rows() == 0){

        $system_info = _MYNGNOGROUPS;
        $main = "error.htm";
        $t->set_file("main",$main);
        $t->set_var("error_message",_MYNGNOGROUPS);
        // Show all the page
        show_layout($t,$left_bar,$system_info,MYNG_VERSION);
        exit();

}

$challenge=md5(uniqid($_SESSION['conf_sec_secret_string']));
$t->set_var("secret_challenge",$challenge);

$system_info = _MYNGMENU_STATS;
$main = "stats.htm";
$t->set_file("main",$main);


$t->set_block("main","hot_groups_block","hot_groups_block_handle");
$t->set_block("main","active_user_block","active_user_block_handle");
$t->set_block("main","crowded_groups_block","crowded_groups_block_handle");
$t->set_block("main","argumentative_user_block","argumentative_user_block_handle");
$t->set_block("main","hot_articles_block","hot_articles_block_handle");
$t->set_block("main","popular_article_block","popular_article_block_handle");
$t->set_block("main","popular_groups_block","popular_groups_block_handle");

//----------- Stats Code ------------------//

$db = new My_db;
$db2 = new My_db;
$db->connect();

//---------------- Hot NewsGroups -------------//

$max_scale = 5000;
$max_width = 200;

$consulta = "SELECT grp_name,grp_num_messages FROM myng_newsgroup ORDER BY grp_num_messages DESC LIMIT 0,5";
$db->query($consulta);
while($db->next_record()){

        $width = ($db->Record['grp_num_messages'] * $max_width) / $max_scale;
        $t->set_var("group_name",$db->Record['grp_name']);
        $t->set_var("num_articles",$db->Record['grp_num_messages']);
        $t->set_var("width",$width);
        $t->parse("hot_groups_block_handle","hot_groups_block",true);
}


//------------ Popular NewsGroups -------------//

$max_scale = 500;
$max_width = 200;

$consulta = sprintf("SELECT grp_name FROM myng_newsgroup");
$db->query($consulta);
$users = array();

$i = 0;
$j = 0;

// For each newsgroup
while($db->next_record()){

        $group_name = real2table($db->Record['grp_name']);
        $consulta2 = sprintf("SELECT number,subject,num_readings,COUNT(*) FROM `%s` group by number","myng_".$group_name);
        //echo $consulta2;
        $db2->query($consulta2);
        while($db2->next_record()){
                $num_readings[$j][0] = $num_readings[$j][0] + $db2->Record['num_readings'];
                $num_readings[$j][1] = $db->Record['grp_name'];

        }
        $j ++;

}

rsort($num_readings);
for($i=0;$i<$j;$i++){

        //echo $num_readings[$i][1].$num_readings[$i][0]."<br>";

        $width = ($num_readings[$i][0] * $max_width) / $max_scale;
        $t->set_var("group_name",$num_readings[$i][1]);
        $t->set_var("num_readings",$num_readings[$i][0]);
        $t->set_var("width",$width);
        $t->parse("popular_groups_block_handle","popular_groups_block",true);


}



//------------- Crowded NewsGroups ----------------//

$max_scale = 500;
$max_width = 200;

$consulta = sprintf("SELECT grp_name FROM myng_newsgroup");
$db->query($consulta);
$users = array();

$i = 0;

// For each newsgroup
while($db->next_record()){

        $group_name = real2table($db->Record['grp_name']);
        $consulta2 = sprintf("SELECT DISTINCT name FROM `%s`","myng_".$group_name);
        $db2->query($consulta2);
        $num_users[$i][0] = $db2->num_rows();
        $num_users[$i][1] = $group_name;

        $i++;
}

rsort($num_users);
for($i=0;$i<count($num_users);$i++){

        $width = ($num_users[$i][0] * $max_width) / $max_scale;
        $t->set_var("group_name",table2real($num_users[$i][1]));
        $t->set_var("num_users",$num_users[$i][0]);
        $t->set_var("width",$width);
        $t->parse("crowded_groups_block_handle","crowded_groups_block",true);

}


//----------------- Hot articles --------------------//

$max_scale = 50;
$max_width = 200;

$consulta = sprintf("SELECT grp_name FROM myng_newsgroup");
$db->query($consulta);

// For each newsgroup
$j = 0;
while($db->next_record()){

        $group_name = $db->Record['grp_name'];

        // First method to do it: more time wasted, more queries to de database...
        /*
        $headers = new articleHeader();
        // Get the parents
        $headers = fetch_bastards($group_name);
        reset($headers);
        for($i=0;$i<count($headers);$i++){
                $c = current($headers);
                // Get the number of children
                $num_children = is_parent($c->id,$group_name);
                $sendername = formatAuthor($c);
                $subject = htmlspecialchars($c->subject);
                $num_replies[$j][0] = $num_children;
                $num_replies[$j][1] = $subject;
                $j ++;
                next($headers);
        }
        */

        // Second method to do it: faster, one query to the database
        // Change the method in thread.php to get the parents!!!
        // With this query, I think that fetch_bastards and is_parent are no more needed!!

        $group_name_for_table = real2table($group_name);
        $consulta2 = sprintf("SELECT `%s`.subject,COUNT(*) FROM `%s`,`myng_ref_%s` WHERE `%s`.isanswer='0' and `%s`.reference=`%s`.id GROUP BY subject","myng_".$group_name_for_table,"myng_".$group_name_for_table,$group_name_for_table,"myng_".$group_name_for_table,"myng_ref_".$group_name_for_table,"myng_".$group_name_for_table);
        //echo $consulta2;
        $db2->query($consulta2);
        while($db2->next_record()){

                $num_replies[$j][0] = $db2->Record[1];
                $num_replies[$j][1] = $db2->Record['subject'];
                $j ++;

        }

}

// Sort the result
rsort($num_replies);
// We only want 5 best results.
for($i=0;$i<5;$i++){

        $width = ($num_replies[$i][0] * $max_width) / $max_scale;
        $t->set_var("subject",$num_replies[$i][1]);
        $t->set_var("num_articles",$num_replies[$i][0]);
        $t->set_var("width",$width);
        $t->parse("hot_articles_block_handle","hot_articles_block",true);
}


//---------------- Popular Articles -------------------//

$max_scale = 500;
$max_width = 200;

$consulta = sprintf("SELECT grp_name FROM myng_newsgroup");
$db->query($consulta);
$users = array();

$i = 0;
$j = 0;

// For each newsgroup
while($db->next_record()){

        $group_name = real2table($db->Record['grp_name']);
        $consulta2 = sprintf("SELECT subject,num_readings,COUNT(*) FROM `%s` group by num_readings","myng_".$group_name);
        //echo $consulta2;
        $db2->query($consulta2);
        while($db2->next_record()){
                $num_readings[$j][0] = $db2->Record['num_readings'];
                $num_readings[$j][1] = $db2->Record['subject'];
                $j ++;
        }


}

rsort($num_readings);
for($i=0;$i<5;$i++){

        //echo $num_readings[$i][1].$num_readings[$i][0]."<br>";

        $width = ($num_readings[$i][0] * $max_width) / $max_scale;
        $t->set_var("subject",$num_readings[$i][1]);
        $t->set_var("num_readings",$num_readings[$i][0]);
        $t->set_var("width",$width);
        $t->parse("popular_article_block_handle","popular_article_block",true);

}




//------------------- Active User --------------------//

$max_scale = 100;
$max_width = 200;

$consulta = sprintf("SELECT grp_name FROM myng_newsgroup");
$db->query($consulta);
$users = array();

$i = 0;
$j = 0;


// For each newsgroup
while($db->next_record()){

        $group_name = real2table($db->Record['grp_name']);
        //echo $group_name;
        $consulta2 = sprintf("SELECT name,COUNT(*) FROM `%s` GROUP BY name","myng_".$group_name);
        //echo $consulta2."<br>";
        $db2->query($consulta2);

        while($db2->next_record()){

                if($db2->Record['name'] != ""){
                        $num_replies[$j][1] = $db2->Record['name'];
                        $num_replies[$j][0] = $db2->Record[1];
                }else{
                        $j--;
                }
                $j ++;
        }
}

rsort($num_replies);

for($j=0;$j<5;$j++){
        //echo $num_replies[$j][0].$num_replies[$j][1]."<br>";
        $width = ($num_replies[$j][0] * $max_width) / $max_scale;
        $t->set_var("username",$num_replies[$j][1]);
        $t->set_var("num_posts",$num_replies[$j][0]);
        $t->set_var("width",$width);
        $t->parse("active_user_block_handle","active_user_block",true);
}


//--------------- Argumentative User -------------------//

$max_scale = 100;
$max_width = 200;

$consulta = sprintf("SELECT grp_name FROM myng_newsgroup");
$db->query($consulta);
$users = array();

$i = 0;
$j = 0;

// For each newsgroup
while($db->next_record()){

        $group_name = real2table($db->Record['grp_name']);
        $consulta2 = sprintf("SELECT name,COUNT(*) FROM `%s` WHERE isanswer='1' GROUP BY name","myng_".$group_name);
        $db2->query($consulta2);

        while($db2->next_record()){

                if($db2->Record['name'] != ""){
                        $num_replies[$j][1] = $db2->Record['name'];
                        $num_replies[$j][0] = $db2->Record[1];
                }else{
                        $j--;
                }
                $j ++;
        }
}

rsort($num_replies);

for($j=0;$j<5;$j++){

        $width = ($num_replies[$j][0] * $max_width) / $max_scale;
        $t->set_var("username",$num_replies[$j][1]);
        $t->set_var("num_replies",$num_replies[$j][0]);
        $t->set_var("width",$width);
        $t->parse("argumentative_user_block_handle","argumentative_user_block",true);


}


// Page Text
$t->set_var("_myngstats",_MYNGMENU_STATS);
$t->set_var("_mynghot_ng",_MYNGHOT_NG);
$t->set_var("_myngpopular_ng",_MYNGPOPULAR_NG);
$t->set_var("_myngcrowded_ng",_MYNGCROWDED_NG);
$t->set_var("_mynghot_articles",_MYNGHOT_ARTICLES);
$t->set_var("_myngpopular_articles",_MYNGPOPULAR_ARTICLES);
$t->set_var("_myngactive_user",_MYNGACTIVE_USER);
$t->set_var("_myngarg_user",_MYNGARG_USER);
$t->set_var("_myngstats_articles",_MYNGSTATS_ARTICLES);
$t->set_var("_myngstats_readings",_MYNGSTATS_READINGS);
$t->set_var("_myngusers",_MYNGUSERS);
$t->set_var("_myngpostings",_MYNGPOSTINGS);
$t->set_var("_myngreplies",_MYNGREPLIES);


// Show all the page
show_layout($t,$left_bar,$system_info,MYNG_VERSION);



?>
