<?

// ---------------------------------------------------------------------------- //
// MyNewsGroups :) 'Share your knowledge'
// Copyright (C) 2002 Carlos Snchez Valle (yosoyde@bilbao.com)

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------- //


//------------------------------------------------------------------//
// tree.php
// Author: Carlos Snchez
// Created: 23/06/01
//
// Description: Thread Page. We show all the 'parents' in a table.
//              We show also the date, the author, the number of
//              articles in the thread, etc.
//
// In:          We need the number of the group to show. We pass
//              it through the URL. 
//
//
//
//------------------------------------------------------------------//
?>
<?
session_start();

// Systemcheck standalone or postnuke
if(LOADED_AS_MODULE=="1") {
	// Define Modulename for Postnuke
	$ModName = basename( dirname( __FILE__ ) );
	$myng['system'] = "postnuke";
	// Include the postnuke config file
	include("modules/$ModName/config.php");
} else {
	$myng['system'] = "standalone";
	// Include the standard config file, with all the configuration and files required.
	include("config.php");
}

$db=new My_db;
$db->connect();

// MyNG setting up...
init();

// Set up the language
modules_get_language();

// Templates
$t = new Template($_SESSION['conf_system_root']."/themes/".$_SESSION['conf_vis_theme']."/templates/");

// Fetch the latest articles
if(!fetch_articles($cron = false)){
	// Redirect to the error page, there're no groups at the system
	header("Location:".$_SESSION['conf_system_prefix']."error.php?error_id=1");	
}

//Registramos el momento actual
$current_time=time();

// Manage the login module
$left_bar = manage_login($current_time,&$t,&$db);

//----------- URL Hacking Protection ---------------------------------------//
/*
if(!$group_name){

        // Display the error Page, with the following error message:
        $error_message = _MYNGNEWSGROUP_UNSELECTED;
        $t->set_var("error_message",$error_message);
        $main = "error.htm";
        $t->set_file("main",$main);
        // Show all the page
        show_layout($t,$left_bar,$system_info,$myng['version']);
        // Stop the script
        exit();
}
*/

// GET Variables
$grp_id = $_GET['grp_id'];
//$group_name = $_GET['group_name'];

//$group_name = table2real($group_name);

// Check if the NewsGroup belongs to the system
$resultado = testgroup($grp_id);

if($resultado==0){

        // Display the error Page, with the following error message:
        $error_message = _MYNGUNKNOWN_GROUP;
        $t->set_var("error_message",$error_message);
        //display_error_page($error_message);
        $main = "error.htm";
        $t->set_file("main",$main);
        // Show all the page
        show_layout($t,$left_bar,$system_info,_MYNG_VERSION);
        // Stop the script
        exit();

}

//--------------------------------------------------------------------------//


//$group_name_for_table = strtr($group_name_for_table,"-","_");


//$left_bar = "login.htm";

$main = "tree.htm";
$t->set_file("main",$main);
$t->set_block("main","bloque_cuadros","bloque_cuadros_handle");
$t->set_block("main","nav_block","nav_block_handle");

// Put some additional data into the session.
$consulta = "SELECT 				
				grp_name,
				grp_last_article,
				grp_first_article,
				grp_num_messages,
				grp_serv_id,grp_allow_post_yn,
				serv_id,
				serv_host 
			FROM myng_newsgroup,myng_server 
			WHERE grp_id ='".$grp_id."' 
			AND grp_serv_id = serv_id";

$db->query($consulta);
$db->next_record();

$group_name = $db->Record['grp_name'];
$group_name_for_table = strtr($group_name,".","_");

// System info
$system_info = $group_name;

//echo $consulta;

$_SESSION['serv_host'] = $db->Record['serv_host'];
$_SESSION['grp_name'] = $group_name;
$_SESSION['grp_last_article'] = $db->Record['grp_last_article'];
$_SESSION['grp_first_article'] = $db->Record['grp_first_article'];
$_SESSION['grp_num_messages'] = $db->Record['grp_num_messages'];
$_SESSION['grp_allow_post_yn'] = $db->Record['grp_allow_post_yn'];

//echo $_SESSION['serv_host'];

$t->set_block("main","thread_block","thread_block_handle");

// Fetch the bastards
// $headers is an array with all the bastard's
// information.

if(isset($_GET['date'])){
	$date = $_GET['date'];
}else{
	$date = "";	
}
$t->set_var("calendar_day",$date);
// -------------- New Navigation Bar Hack!! -----------------//

// Get the page number
if(!isset($_GET['page'])){
    $page = 1;
}else{ 
	$page = $_GET['page'];
}

if($date ==""){
	$query = "SELECT count(*) FROM `"."myng_".real2table($group_name)."` WHERE isanswer='0'";
}else{
	$query = "SELECT count(*) FROM `"."myng_".real2table($group_name)."` WHERE isanswer='0' AND FROM_UNIXTIME(UNIX_TIMESTAMP('".$date."'),'%d') = FROM_UNIXTIME(date,'%d')";	
}
$db->query($query);
$db->next_record();
// Number of elements to show
$num_elements = $db->Record[0];
$t->set_var("group_name_table",$group_name_for_table);
//echo $num_elements.$page.$_SESSION['conf_vis_nav_bar_items'];
navigation_bar($num_elements,$page);

// Para limitar la consulta a la base de datos
$primer_elemento = ($page - 1) * $_SESSION['conf_vis_nav_bar_items'];

$begin = $primer_elemento;



//------------------------------------------------------------//

$headers = new articleHeader();

$headers = fetch_bastards($group_name,$begin,$_SESSION['conf_vis_nav_bar_items'],$date);
reset($headers);

for($i=0;$i<count($headers);$i++){

        $c = current($headers);

        $num_children = is_parent($c->id,$group_name);

        $article_url = $c->id;
        $article_url = rawurlencode($article_url);
        $article_url = "article.php?id_article=".$article_url;
        $article_url = $article_url."&grp_id=".$grp_id;

        // -- Contributed by Kevin # Show the date in the local way -- //
        $date = date(_MYNGDATEDISPLAY,$c->date);
        //$date = date("M d Y",$c->date);

        $sendername = formatAuthor($c);
        $t->set_var("sender_name",$sendername);
        $t->set_var("date",$date);
        $group_name = strtr($group_name,"_",".");
        $t->set_var("group_name",$group_name);
        $t->set_var("article_url",modifyLink($article_url));
        $t->set_var("subject",htmlspecialchars($c->subject));

        //---------------- User Login System Module ------------------ //
        
        // Check if we are in a session
        if(isset($_SESSION['usr_name'])){

                // Try to show the unread articles
                $query = "
                	SELECT lib_art_id 
                	FROM myng_library 
                	WHERE lib_usr_id='".$_SESSION['usr_id']."' 
                	AND lib_grp_id ='".$grp_id."' 
                	AND lib_art_id='".$c->id_article."'";
                $db->query($query);

                if($db->num_rows() == 0){
                        // Unread article, Highlight it!
                        $unread = "yes";
                        $class = "normal_bold";
                        $bg_color = "#FFFFFF";
                }else{
                        $unread="no";
                        $class = "normal";
                        $bg_color = "#eeeeff";
                }

                // Try to show the new articles
                $query = "
                	SELECT subs_last_article 
                	FROM myng_subscription 
                	WHERE subs_usr_id='".$_SESSION['usr_id']."' 
                	AND subs_grp_id ='".$grp_id."'";
                $db->query($query);

                if($db->num_rows() != 0){

                        $db->next_record();
                        // Group registered in mygroups.

                        //echo $db->Record['last_article'];
                        //echo $c->number;
                        //echo $Session['group']['last_article'];
                        global $Group;
                        if( ($db->Record['grp_last_article'] < $c->number) && ($c->number <= $_SESSION['grp_last_article']) ){
                                // This is a new article!
                                //$class = "normal_bold";
                                if($unread == "yes"){
                                        $bg_color = "#FFFFCC";
                                }

                        }

                }else{
                        // Group NOT registered in mygroups.
                        // Do somethign here??
                }
                
        //---------------------------------------------------//

        }else{
                // We are not in a session.
                $class = "normal";
                $bg_color = "#eeeeff";
        }

        $t->set_var("class",$class);
        $t->set_var("bg_color",$bg_color);
        $t->set_var("number",$num_children);

        // --- Oops!! Get this HTML out of here!! ------ //
        if($num_children != 0 ){
                $image = "<img src=".$myng_dir['images']."/plus.gif width=9 alt=".$message." height=9>";
        }else{
                $image="<font class=\"small\" color=\"#E2ECF5\">-</font>";

        }

        $t->set_var("image",$image);
        $t->parse("thread_block_handle","thread_block",true);

        next($headers);

}


// Variables to put X articles per page
if(count($headers) < $_SESSION['conf_vis_articles_x_page']){
        $begin_next = $begin;
}else{
        $begin_next = ($begin + $_SESSION['conf_vis_articles_x_page']);
}
$begin_previous = ($begin - $_SESSION['conf_vis_articles_x_page']);
if($begin_previous < 0){
        $begin_previous = 0;
}

$next_url = modifyLink("tree.php?group_name=".rawurlencode($group_name_for_table)."&begin=".$begin_next);
$previous_url = modifyLink("tree.php?group_name=".rawurlencode($group_name_for_table)."&begin=".$begin_previous);
$post_url = modifyLink("post.php?grp_id=".$grp_id."&newsgroups=".rawurlencode($group_name_for_table)."&type=new");
$t->set_var("post_url",modifyLink($post_url));
$t->set_var("next_url",modifyLink($next_url));
$t->set_var("previous_url",modifyLink($previous_url));

// Calendar Class code

$cal = new MyNGCalendar;
$cal->setStartDay(1);
$grp_name = $group_name;
$cal->getDateLink($day,$month,$year,$group_name);
$t->set_var("calendar",$cal->getCurrentMonthView());


// Page Text
$t->set_var("_myngsearch_one_group",_MYNGSEARCH_ONE_GROUP);
$t->set_var("_myngpost_article",_MYNGPOST_ARTICLE);
$t->set_var("_myngdate",_MYNGDATE);
$t->set_var("_myngsubject",_MYNGSUBJECT);
$t->set_var("_myngauthor",_MYNGAUTHOR);
$t->set_var("_myngarticles",_MYNGARTICLES);
$t->set_var("_myngprevious",_MYNGPREVIOUS);
$t->set_var("_myngnext",_MYNGNEXT);
$t->set_var("_mynggo",_MYNGGO);
$t->set_var("_myngsubscribe_group",_MYNGSUBSCRIBE_GROUP);

$t->set_var("grp_id",$grp_id);

$challenge=md5(uniqid($_SESSION['conf_sec_secret_string']));
$t->set_var("secret_challenge",$challenge);

// Show all the page
show_layout($t,$left_bar,$system_info,MYNG_VERSION);

?>
